
Ext.define('DSS.component.conditionCcolumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.conditioncolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }   
        var customRendererOptions = {
        	hideEnabled:false,
        	hideWeekdays:false,
        	hideGenericSystemStates:false,
        	hideZoneStates:false,
        	hideTimeframe:false,
        	filterSystemState:[],
        	stateTitles:[]};
        
        if (view.up().customRendererOptions!=null)
            if (view.up().customRendererOptions[colIdx]!=null) {
            	customRendererOptions=view.up().customRendererOptions[colIdx];           	
            }
        var oRecord = val;
        var sResult = "<table>";
        if (!customRendererOptions.hideEnabled)
        if (oRecord.enabled!=null) {
            if (oRecord.enabled)
            	sResult+='<tr><td colspan="2">' +  _('entry is enabled') + '</td></tr>';
            else
            	sResult+='<tr><td colspan="2">' +  _('entry is disabled') + '</td></tr>';
            
        }
        
        if (!customRendererOptions.hideTimeframe)
        if (oRecord.timeframe!=null) {
        	function calcTimeframeString(oTimeObjectStart,oTimeObjectEnd) {
        			var pad = function(i) { return (i < 10 ? '0'+i : i); };
                
                var sStart="";
                if (oTimeObjectStart.timeBase=="daily") {
                    var sStart=  pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sStart=  pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60));

                    switch (oTimeObjectStart.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunset');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunrise');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dawn');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dusk');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectStart.limitBefore!=null)  {
                        sStart+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/60)%60))});
                    }
                    if (oTimeObjectStart.limitAfter!=null)  {
                        sStart+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/60)%60))});
                    }
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                }
                
                var sEnd="";
                if (oTimeObjectEnd.timeBase=="daily") {
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60));

                    switch (oTimeObjectEnd.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunset');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunrise');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dawn');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dusk');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectEnd.limitBefore!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/60)%60))});
                    }
                    if (oTimeObjectEnd.limitAfter!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/60)%60))});
                    }
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                }

                return Ext.String.format2(_('only between {startTime} and {endTime}'),{startTime:sStart,endTime:sEnd});
        	}
        	
        	for (var iIndex=0;iIndex<oRecord.timeframe.length;iIndex++) {
        		sResult += '<tr><td style="padding-right:5px;"><img src="'+dss.staticDataModel.baseImagePath+'dss/time_condition.png"></td><td>' + calcTimeframeString(oRecord.timeframe[iIndex].start,oRecord.timeframe[iIndex].end) + '</td></tr>';
        	}
        		
        }
        if (!customRendererOptions.hideWeekdays)
        if (oRecord.weekdays!=null) {
        	function calcWeekdayString(recObject) {
        	 var sString = '<table><td style="padding-right:5px;"><img src="'+dss.staticDataModel.baseImagePath+'dss/weekday_condition.png"></td><td><span>';
             
             var fMo = false;
             var fDi = false;
             var fMi = false;
             var fDo = false;
             var fFr = false;
             var fSa = false;
             var fSo = false;
             if (recObject.length == 7)
                 return sString + _("daily") + "</span></td></tr></table>";
             for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                 if (recObject[iIndex] == 'MO')
                     fMo = true;
                 if (recObject[iIndex] == 'TU')
                     fDi = true;
                 if (recObject[iIndex] == 'WE')
                     fMi = true;
                 if (recObject[iIndex] == 'TH')
                     fDo = true;
                 if (recObject[iIndex] == 'FR')
                     fFr = true;
                 if (recObject[iIndex] == 'SA')
                     fSa = true;
                 if (recObject[iIndex] == 'SU')
                     fSo = true;
             }
             sString += _('only ') ;
             if (recObject.length == 2)
                 if (fSa)
                     if (fSo)
                         return sString  + _('on weekends')+'</span></td></tr></table>';
     
             if (recObject.length == 5)
                 if (fMo)
                     if (fDi)
                         if (fMi)
                             if (fDo)
                                 if (fFr)
                                     return sString + _('MO-FR')+'</span></td></tr></table>';
             if (recObject.length == 1) {
                 if (fMo)
                     return sString + _("on monday")+"</span></td></tr></table>";
                 if (fDi)
                     return sString + _("on tuesday")+"</span></td></tr></table>";
                 if (fMi)
                     return sString + _("on wednesday")+"</span></td></tr></table>";
                 if (fDo)
                     return sString + _("on thursday")+"</span></td></tr></table>";
                 if (fFr)
                     return sString + _("on friday")+"</span></td></tr></table>";
                 if (fSa)
                     return sString + _("on saturday")+"</span></td></tr></table>";
                 if (fSo)
                     return sString + _("on sunday")+"</span></td></tr></table>";
             }
             if (recObject.length == 0) {
                 return sString + _("no time defined")+"</span></td></tr></table>";                
             }
              
             if (fMo)
                 sString += '<b>'+_('MO')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('MO')+'</span> ,';
             if (fDi)
                 sString += '<b>'+_('TU')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TU')+'</span> ,';
             if (fMi)
                 sString += '<b>'+_('WE')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('WE')+'</span> ,';
             if (fDo)
                 sString += '<b>'+_('TH')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TH')+'</span> ,';
             if (fFr)
                 sString += '<b>'+_('FR')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('FR')+'</span> ,';
             if (fSa)
                 sString += '<b>'+_('SA')+'</b> ,';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SA')+'</span> ,';
             if (fSo)
                 sString += '<b>'+_('SU')+'</b>';
             else
                 sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SU')+'</span>';
             return sString + "</span></td></tr></table>";
        	}
        	sResult+='<tr><td colspan="2">' + calcWeekdayString(oRecord.weekdays) + '</td></tr>';
        }           
        
        if (oRecord.systemState!=null) {
        	for (var iIndex=0;iIndex<oRecord.systemState.length;iIndex++) {
        		var fShow=true;
        		if (customRendererOptions.hideGenericSystemStates) {
        			fShow=false;
        			for (var kIndex=0;kIndex<customRendererOptions.filterSystemState.length;kIndex++) {
        				if (customRendererOptions.filterSystemState[kIndex]==oRecord.systemState[iIndex].name)
        					fShow=true;
        			}
        		}
        		var sIcon=dss.staticDataModel.getImagePathForState(oRecord.systemState[iIndex].name,oRecord.systemState[iIndex].value);
        		var fShown=false;
        		if (fShow) {
        			if (customRendererOptions.stateTitles!=null)
        				if (customRendererOptions.stateTitles.length!=null)
        					for (var kIndex=0;kIndex<customRendererOptions.stateTitles.length;kIndex++) {
        						var sStateName=oRecord.systemState[iIndex].name;
        						var sSuffix="";
        						if (sStateName.split('.').length==2) {
        	        				for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) 
        	        					if (sStateName.split('.')[1] == "group" + dss.staticDataModel.userGroups[lIndex].id) {
        	        						sStateName=sStateName.split('.')[0];
        	        						sSuffix=_(' in ') + dss.staticDataModel.userGroups[lIndex].name;
        	        					}        							
        						}         							
        						if (customRendererOptions.stateTitles[kIndex].name==sStateName)
            						if (customRendererOptions.stateTitles[kIndex].value==oRecord.systemState[iIndex].value) {
            							if (sIcon!=null)
            								sResult+='<tr><td style="padding-right:5px;" colspan="1"><img src="' + sIcon + '"></td><td>' + customRendererOptions.stateTitles[kIndex].title + sSuffix + '</td></tr>';
            							else
            								sResult+='<tr><td colspan="2">' + customRendererOptions.stateTitles[kIndex].title + sSuffix + '</td></tr>';
            		        			fShown=true;
            						}
        					}
        		}
        		if (!fShown) {
        			var sError="";
                   	var oArray=oRecord.systemState[iIndex].name.split('.');
                	if (oArray.length==3) {
                    	if (oArray[0]=='dev')
                    	{
                    		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
                    		if (oDevice!=null) {
                    			var sString = oDevice.name + " in ";
                                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                                var typeIndex=parseInt(oArray[2],10);
                                var type=255;
                                if (oDevice.binaryInputs!=null)
	                                for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
	                                	if (oDevice.binaryInputs[kIndex].index==typeIndex)
	                                		type=oDevice.binaryInputs[kIndex].type;
                                
                                
	                            var oParameter={
		                            	device:oDevice.name,
		                            	zone_of_device:dss.staticDataModel.getNameForZone(oDevice.ZoneID),
		                            };
	                            
	                            if (oRecord.systemState[iIndex].value==1)
	                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(oArray[1],type,true);
	                            else
	                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(oArray[1],type,false);
	                            
	                            var sString = Ext.String.format2(_("{#grid_condition_column_akm_state}{state_value} on {device} in {zone_of_device}"),oParameter);
                                                                
	                            sResult += '<tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString + '</td></tr>';
                                continue;
                    		}
                    	}
                    	
                    	if (oArray[0]=='zone') {
	                		var sNameOfZone=dss.staticDataModel.getNameForZone(parseInt(oArray[1],10));
	                		if (oArray[2]=='light') {
	                			if (oRecord.systemState[iIndex].value==1) {
		                            var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}light in {zone} is on"),{'zone':sNameOfZone});
		                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,5) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
	                			} else {
	                			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}light in {zone} is off"),{'zone':sNameOfZone});
			                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,0) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
	                			}
	                			break;
	                		} else
	                		if (oArray[2]=='motion') {
	                			if (oRecord.systemState[iIndex].value==1) {
		                            var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}motion in {zone} is reported"),{'zone':sNameOfZone});
		                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,5,true) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
	                			} else {
	                			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}no motion in {zone} is reported"),{'zone':sNameOfZone});
			                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,5,false) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
	                			}
	                			break;
	                		} else
		                		if (oArray[2]=='presence') {
		                			if (oRecord.systemState[iIndex].value==1) {
			                            var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}presence in {zone} is reported"),{'zone':sNameOfZone});
			                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,1,true) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
		                			} else {
		                			    var sString = Ext.String.format2(_("{#grid_condition_column_zone_state}absence in {zone} is reported"),{'zone':sNameOfZone});
				                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,1,false) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
		                			}
		                			break;
		                		}
	                	}
                    	
                	}         	
					if (sIcon!=null)
						sResult+='<tr><td style="padding-right:5px;" colspan="1"><img src="' + sIcon + '"></td><td>' + Ext.String.format2(_('{#grid_condition_column_generic_state}' + oRecord.systemState[iIndex].name + '_' + oRecord.systemState[iIndex].value),{}) + '</td></tr>';
					else                	
						sResult+='<tr><td colspan="2">' + Ext.String.format2(_('{#grid_condition_column_generic_state}' + oRecord.systemState[iIndex].name + '_' + oRecord.systemState[iIndex].value),{}) + '</td></tr>';
        		}
        	}
        }
        if (!customRendererOptions.hideZoneStates)
        if (oRecord.zoneState!=null) {
        	for (var iIndex=0;iIndex<oRecord.zoneState.length;iIndex++) {
	        	var oZone=oRecord.zoneState [iIndex];
	        	sResult += '<tr><td style="padding-right:5px;height:16px;">' + dss.staticDataModel.getImageForScene(oZone.zone, oZone.group, oZone.scene) + "</td>";
	            
	        	sResult += '<td style="">';
	
	        	sResult += dss.staticDataModel.getNameForScene(oZone.zone, oZone.group, oZone.scene);
	            if (oZone.group != 0)
	            	sResult += _(' for ') + dss.staticDataModel.getNameForGroup(oZone.zone, oZone.group);
	            
	            if (oZone.zone != 0)
	            	sResult += _(' in ') + dss.staticDataModel.getNameForZone(oZone.zone);
	            else
	                if (oZone.scene < 64)
	                	sResult += _(' in all rooms');
	
	            sResult += "</td></tr>";
        	}
        }
       
            if (oRecord.addonStates!=null) {
            	for (var iIndex=0;iIndex<oRecord.addonStates.length;iIndex++) {
    	        	var oZone=oRecord.addonStates [iIndex];
    	        	sResult += '<tr><td style="" colspan="2">';
    	
    	        	sResult += oRecord.addonStates [iIndex].name;
    	        	sResult += ' must be ';
    	        	sResult += oRecord.addonStates [iIndex].value;
    	        	sResult += ' for App ';
    	        	sResult += oRecord.addonStates [iIndex].scriptID;

    	
    	            sResult += "</td></tr>";
            	}
            }
            
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+sResult + "</table>"+'</span>';
        else
        	return sResult + "</table>";   

    }});

Ext.define('DSS.component.triggerColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.triggercolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var oRecord = val;
        var sResult = "<table>";
        var f1tip = false;
        var f2tip = false;
        var f3tip = false;
        for ( var iIndex = 0; iIndex < oRecord.length; iIndex++) {
            var oAction = oRecord[iIndex];
            
            
            var fValid= dss.validateTriggerObject(oAction);
            var sError="";
            if (fValid==dss.validValue.completlyWrong)
                sError="color:#ff0000;";
            if (fValid==dss.validValue.temporaryWrong)
                sError="color:#aaaaaa;";
            
            sResult += "<tr>";
            switch (oAction.type) {
	            case 'addon-state-change' :{
            		if (oAction['addon-id']=="user-defined-states") {
	        			var idString =oAction.name.split('_')[1];
	        			
	        			var oUserStates=dss.staticDataModel.getUserStates();
	        			var sStringValue;
	        			for (var jIndex=0;jIndex<oUserStates.length;jIndex++) {
	            			if (oUserStates[jIndex].id==idString) {
	            				if (oAction.state=='active')
	            					sStringValue=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[jIndex].name)});
	            				else
	            					sStringValue=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[jIndex].name)});
	            			}
	            		}
	        			
		        		var sString = '<td style="'+sError+'padding-right:5px;"></td>';   
		        		sString += '<td style="'+sError+'">' +  sStringValue;
		        		sString += "</td>";
		        		sResult += sString; 
		        		break;
	        		} else {
	        			var sString = '<td style="'+sError+'padding-right:5px;"></td>';   
		        		sString += '<td style="'+sError+'"><b>' + oAction['name'] + '</b> change to <b>' + oAction['state'] + '</b> for App <b>' + oAction['addon-id'] + '</b> (internal)';
		        		sString += "</td>";
		        		sResult += sString; 
		        		
	        		}

	            	break;
	            }
            	case 'state-change' :{
            		            		
                  	var oArray=oAction.name.split('.');
                	if (oArray.length==3)  {
	                	if (oArray[0]=='dev') {
	                		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
	                		if (oDevice.present!=null) {
	                			var typeIndex=parseInt(oArray[2],10);
	                            var type=255;
	                            for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
	                            	if (oDevice.binaryInputs[kIndex].index==typeIndex)
	                            		type=oDevice.binaryInputs[kIndex].type;

	                            var oParameter={
		                            	device:oDevice.name,
		                            	zone_of_device:dss.staticDataModel.getNameForZone(oDevice.ZoneID),
		                            };
	                            
	                            if (oAction.state=='active')
	                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(oArray[1],type,true);
	                            else
	                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(oArray[1],type,false);
	                            
	                            var sString = Ext.String.format2(_("{#grid_trigger_column_akm_state}{state_value} on {device} in {zone_of_device}"),oParameter);
	                            
	                            
	                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString + '</td>';
	                            break;
	                		} else {
	                            var sString = Ext.String.format2(_("{#grid_trigger_column_akm_state}{state_value} on {device} in {zone_of_device}"),{'state_value':'?','device':'?','zone_of_device':'?'});
	                            sResult += '<td style="padding-right:5px;"></td><td style="'+sError+'">' + sString + '</td>';	
	                            break;
	                		}
	                	}
	                	if (oArray[0]=='zone') {
	                		var sNameOfZone=dss.staticDataModel.getNameForZone(parseInt(oArray[1],10));
	                		if (oArray[2]=='light') {
	                			if (oAction.state=='active') {
		                            var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}light in {zone} is on"),{'zone':sNameOfZone});
		                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,5) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
	                			} else {
	                			    var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}light in {zone} is off"),{'zone':sNameOfZone});
			                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,0) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
	                			}
	                			break;
	                		} else
		                		if (oArray[2]=='motion') {
		                			if (oAction.state=='active') {
			                            var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}motion in {zone} is reported"),{'zone':sNameOfZone});
			                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,5,true) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
		                			} else {
		                			    var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}no motion in {zone} is reported"),{'zone':sNameOfZone});
				                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,5,false) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
		                			}
		                			break;
		                		} else
			                		if (oArray[2]=='presence') {
			                			if (oAction.state=='active') {
				                            var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}presence in {zone} is reported"),{'zone':sNameOfZone});
				                            sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,1,true) + '"></td><td style="'+sError+'">'+ sString + '</td>';		                					                            	
			                			} else {
			                			    var sString = Ext.String.format2(_("{#grid_trigger_column_zone_state}absence in {zone} is reported"),{'zone':sNameOfZone});
					                        sResult += '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(0,1,false) + '"></td><td style="'+sError+'">' + sString + '</td>';	        					                            	
			                			}
			                			break;
			                		}
	                	}
                	}
            		
            		var sString = '<td style="'+sError+'padding-right:5px;">' + 
            			'<img src="'+dss.staticDataModel.getImagePathForState(oAction.name, oAction.state) + '"></td>';   
            		sString += '<td style="'+sError+'">' +Ext.String.format2(_("grid_"+oAction.name + "_" + oAction.state));  
                    sString += "</td>";
                    sResult += sString;                    
            		break;
            	}
                case 'device-sensor': {
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                    
                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString = _('consumptionmessage') + ' ' + dss.staticDataModel.getNameForSensorEvent(oDevice,oAction.eventid) + ' ' + _('from') + ' ' + sString + "</td>";
                    sResult += '<td style="'+sError+'padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString;
                    break;
                }
                case 'undo-zone-scene': { // scene,
                    // group,zone,force
                    var sString = '<td style="'+sError+'padding-right:5px;">' +
                           dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene,true) + "</td>";

                    sString += '<td style="'+sError+'">' +  _('Undo ') + dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    if (oAction.group != 0)
                        sString += _(" for ") + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'zone-scene': { // scene,
                    // group,zone,force
                    var sString = '<td style="'+sError+'padding-right:5px;">'
                            + dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene) + "</td>";

                    sString += '<td style="'+sError+'">';
                    if (oAction.forced)
                        sString += _('all ');   
                    sString += dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    
                    if (oAction.group != 0)
                        sString += _(" for ") + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'device-scene': {
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + _(" in ");
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    switch (oAction.scene) {
                        case 50:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                    + _('local off from') + ' ' +sString + "</td>";
                        break;
                        case 51:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                    + _('local on from') + ' ' +sString + "</td>";
                        break;
                    }
                    sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                    break;
                }
                case 'device-msg': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    switch (oAction.msg) {
                        case 7:
                        case 0:
                            if (oAction.buttonIndex!=null) {
                                f1tip = true;
                                if (oAction.buttonIndex==2) {
                                    sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                            + _('switch down') + _(' from ') + sString + "</td>";
                                    sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                                }
                                if (oAction.buttonIndex==1) {
                                    sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                            + _('switch up') + _(' from ') + sString + "</td>";
                                    sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                                }
                            }

                            if (f1tip == false) {                                
                                sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                        + _('1x click') + _(' from ') + sString + "</td>";
                                sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                            }
                            f1tip = true;
                        break;
                        case 8:
                        case 1:
                            if (f2tip == false) {
                                sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                        + _('2x click') + _(' from ') + sString + "</td>";
                                sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                            }
                            f2tip = true;
                        break;
                        case 9:
                        case 2:
                            if (f3tip == false) {
                                sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                        + _('3x click') + _(' from ') + sString + "</td>";
                                sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                            }
                            f3tip = true;
                        break;
                        case 3:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                    + _('4x click') + _(' from ') + sString + "</td>";
                            sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                        break;
                        case 6:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                    + _('hold') + _(' from ') + sString + "</td>";
                            sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                        break;
                        case 10:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice)
                                    + '"></td><td>' + _('short-long-click') + _(' from ') + sString + "</td>";
                            sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                        break;
                    }

                    break;
                }
                case 'device-binary-input': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    switch (oAction.state) {
                        case 0:
                        	sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                            	+ _('switch up') + _(' from ') + sString + "</td>";
                        	sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                        	break;
                        case 1:
                            sString = '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                            	+ _('switch down') + _(' from ') + sString + "</td>";
                            sResult += '<td style="'+sError+'padding-right:5px;">' + sString;
                            break;
                    }

                    break;
                }
                case 'custom-event': { // event
                    sResult += '<td style="'+sError+'" colspan="2">'+_('Action')+': ' + dss.staticDataModel.getHLENameFromId(oAction.event) + '</td>';
                    break;
                }
            }
            sResult += "</tr>";
        }
         
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+sResult + "</table>"+'</span>';
        else
        	return sResult + "</table>";    
    }
});

Ext.define('DSS.component.actionColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.actioncolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var oRecord = val;
        var sResult = "<table>";
        var fShowDelay=false;
        
        for ( var iIndex = 0; iIndex < oRecord.length; iIndex++) {
            var oAction = oRecord[iIndex];
            if (oAction.delay!=null)
                if (oAction.delay!=0)
                    fShowDelay=true;
        }
        
        if (fShowDelay) {
            oRecord.sort(function (a,b) {   if (a.delay==null)
                                                a.delay=0;
                                            if (b.delay==null)
                                                b.delay=0;
                                            return a.delay - b.delay;
                                         });
        }
        
        for ( iIndex = 0; iIndex < oRecord.length; iIndex++) {
            var oAction = oRecord[iIndex];
            
            var fValid= dss.validateActionObject(oAction);
            var sError="";
            if (fValid==dss.validValue.completlyWrong)
                sError="color:#ff0000;";
            if (fValid==dss.validValue.temporaryWrong)
                sError="color:#aaaaaa;";
            
            sResult += "<tr>";
            if (fShowDelay) {
                if (oAction.delay==0)
                    sResult += "<td></td>";
                else
                    sResult += '<td align="right"> +' + Math.floor(oAction.delay/60) + ' ' + _('min.') +'</td>'; 
            }
            switch (oAction.type) {
            	case 'change-addon-state': {
	        		if (oAction['addon-id']=="user-defined-states") {
	        			var idString =oAction.statename.split('_')[1];
	        			
	        			var oUserStates=dss.staticDataModel.getUserStates();
	        			var sStringValue;
	        			for (var jIndex=0;jIndex<oUserStates.length;jIndex++) {
	            			if (oUserStates[jIndex].id==idString) {
	            				if (oAction.state=='active')
	            					sStringValue=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[jIndex].name)});
	            				else
	            					sStringValue=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[jIndex].name)});
	            			}
	            		}
	        			
		        		var sString = '<td style="'+sError+'padding-right:5px;"></td>';   
		        		sString += '<td style="'+sError+'">' +  sStringValue;
		        		sString += "</td>";
		        		sResult += sString;
		        		break;
	        		} else {	        			
	        			var sString = '<td style="'+sError+'padding-right:5px;"></td>';   
		        		sString += '<td style="'+sError+'"><b>' + oAction['statename'] + '</b> change to <b>' + oAction['state'] + '</b> for App <b>' + oAction['addon-id'] + '</b> (internal)';
		        		sString += "</td>";
		        		sResult += sString; 			        		
	        		}
            		break;
            	}
            	case 'change-state' :{
	        		
	        		var sString = '<td style="'+sError+'padding-right:5px;">' + 
	        			'<img src="'+dss.staticDataModel.getImagePathForState(oAction.statename, oAction.state) + '"></td>';   
	        		sString += '<td style="'+sError+'">' +  dss.staticDataModel.getNameForState(oAction.statename, oAction.state);
	                sString += "</td>";
	                sResult += sString;                  
	        		break;
	        	}
                case 'zone-value': { // scene, group,zone,force
                    var sString = '<td colspan="2" style="'+sError+'">' + Math.round(oAction.value / 2.55) + "%";
                    if (oAction.group != 0)
                        sString += _(" for ") + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    else
                        sString += _(' in all rooms');

                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'undo-zone-scene': { // scene,
                    // group,zone,force
                    var sString = '<td style="padding-right:5px;">' +
                            dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene,true) + "</td>";

                    sString += "<td>" + _('Undo ') + dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    if (oAction.group != 0)
                        sString += _(" for ") + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    if (oAction.force)
                        sString += ' !';
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'zone-scene': { // scene, group,zone,force
                    var sString = '<td style="padding-right:5px;'+sError+'">'
                            + dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene) + "</td>";

                    sString += '<td style="'+sError+'">';
                    if (oAction.force)
                        sString += _('all ');                    
                    sString += dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    if (oAction.group != 0)
                        sString += _(' for ') + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    else {
                        if ((oAction.group>15)&& (oAction.group<24))
                        	;//usergruppen haben einen eigenen namen
                        else if (oAction.scene < 64)
                            sString += _(' in all rooms');
                    }
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'device-scene': {// scene, dsid,force

                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + _(" in ");
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                    if (oAction.scene == 13) {// aus
                    	var sAction = (oDevice.GroupID==2)?_(' close'):_(' turn off');
                    	
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                + sString + sAction +"</td>";
                    } else if (oAction.scene == 14) {// ein
                    	var sAction = (oDevice.GroupID==2)?_(' open'):_(' turn on');
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                + sString + sAction +"</td>";
                    } else if (oAction.scene == 51) { // ein loc
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">'
                                + sString + _(" turn local on")+"</td>";
                    } else {
                        sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, oAction.scene) + _(" for ") + sString+ "</td>";
                        if (oAction.force)
                            sString = _('all ') + sString;
                        sString = '<td style="padding-right:5px;'+sError+'">'
                                + dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID, oAction.scene) + '</td><td style="'+sError+'">' + sString;
                    }
                    sResult += sString;

                    break;
                }
                case 'device-value': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                    var sString = '<td colspan="2" style="'+sError+'">' + Math.round(oAction.value / 2.55) + "%" + _(" for ");
                    sString += oDevice.name + _(" in ");
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += "</td>";
                    sResult += sString;

                    break;
                }
                case 'device-blink': {// dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                    var sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += '<td style="'+sError+'">' + oDevice.name + _(" in ");
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += " " + _('blinking') +"</td>";
                    sResult += sString;
                    break;
                }
                case 'zone-blink': {// group,zone
                    var sString = '<td style="padding-right:5px;"><img src="'+dss.staticDataModel.baseImagePath+'sceneIcons/scene_blink.png"></td>';
                    sString += '<td style="'+sError+'">' + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone!=0)
                        sString += _(" in ") + dss.staticDataModel.getNameForZone(oAction.zone);
                    else if ((oAction.group>15)&& (oAction.group<24))
                    	;//usergruppen haben einen eigenen Namen
                    else 
                        sString += _(" in all rooms");
                    sString += " " + _('blinking') + "</td>";
                    sResult += sString;
                    break;
                }
                case 'custom-event': { // event
                    sResult += '<td colspan="2" style="'+sError+'">'+ _('action') +': ' + dss.staticDataModel.getHLENameFromId(oAction.event) + '</td>';
                    break;
                }
                case 'url': { // url
                    sResult += '<td colspan="2" style="'+sError+'">URL: ' + oAction.url + '</td>';
                    break;
                }
            }
            sResult += "</tr>";
        }
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+sResult + "</table>"+'</span>';
        else
        	return sResult + "</table>";      

    }
});

Ext.define('DSS.component.timespanColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timespancolumn',
    renderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        var sec = val;
        var min = Math.floor(sec / 60);
        sec -= min * 60;
        var hou = Math.floor(min / 60);
        min -= hou * 60;
        
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+pad(hou) +':'+ pad(min) +':'+ pad(sec)+'</span>';
        else
        	return pad(hou) +':'+ pad(min) +':'+ pad(sec);        	

    },
});

Ext.define('DSS.component.textColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.textcolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+unescape(val)+'</span>';
        return unescape(val);
    }
});

Ext.define('DSS.component.deviceNameColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.devicenamecolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }

        var oDevice = dss.staticDataModel.getDevice(val);
        var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
        sString += '<td>' + oDevice.name + _(" in ");
        sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID) + '</td></tr></table>'; 
        
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+sString+'</span>';
        else
        	return sString;        	

    }
});

Ext.define('DSS.component.deviceNameShortColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.devicenameshortcolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }

        var oDevice = dss.staticDataModel.getDevice(val);
        var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
        sString += '<td>' + oDevice.name +  '</td></tr></table>'; 
        
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+sString+'</span>';
        else
        	return sString;        	

    }
});

Ext.define('DSS.component.deviceDSIDColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.devicedsidcolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+val+'</span>';
        else
        	return val;        	
    }
});

Ext.define('DSS.component.dateColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.datecolumn',
    renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {        
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<span style="color:grey;">'+Ext.Date.format(val, "l, d.m.Y H:i")+'</span>';
        else
        	return Ext.Date.format(val, "l, d.m.Y H:i");        	
    }
});


Ext.define('DSS.component.checkColumn', {
    extend: 'Ext.grid.column.Column',
    alias: 'widget.disabledcolumn',
    
    constructor: function() {
        this.addEvents('checkchange');
        this.callParent(arguments);
    },

    processEvent: function(type, view, cell, recordIndex, cellIndex, e) {
        if (type == 'mousedown') {
            var record = view.panel.store.getAt(recordIndex);
            
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return this.callParent(arguments);
            
            fActive=view.up().isEnablerActive(record);
            if (!fActive)
            	return this.callParent(arguments);
            
            var dataIndex = this.dataIndex;
            var checked = !record.get(dataIndex);
                
            record.set(dataIndex, checked);
            this.fireEvent('checkchange', this, record, recordIndex, checked);
            return this.callParent(arguments);
        }
    },

    renderer : function(val, metadata, record, rowIdx, colIdx, store, view){
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var fActive=view.up().isFieldActive(record);
        if (!fActive)
        	return '<div style="width:13px;height:13px; background-position: 0px -13px;" />';

        var fActive=view.up().isEnablerActive(record);
        if (!fActive)
        	return '<div style="width:13px;height:13px; background-position: 0px -13px;" />';

        if (!val) {
            return '<div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" />';
        } else {
            return '<div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" />';            
        }
    }
});


Ext.define('DSS.component.timeColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timecolumn',
    renderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
            
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        if (val.timeBase=="daily") {
            var sText=  pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
                        pad(Math.floor(Math.abs(val.offset/60)%60)) + " " + _("o'clock");
            if (val.random!=null) {
                sText="&plusmn;" + sText;
            } 
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+sText+'</span>';
            else
            	return sText;        	
        } else {
            
            var sText=  pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
                        pad(Math.floor(Math.abs(val.offset/60)%60));

            switch (val.timeBase)
            {
                case 'sunset':
                    if (val.offset==0)
                        sText = _('at sunset');
                    else if (val.offset<0)
                        sText = Ext.String.format2(_("{time} before sunset"),{time:sText});
                    else
                        sText = Ext.String.format2(_("{time} after sunset"),{time:sText});
                break;
                case 'sunrise':
                    if (val.offset==0)
                        sText = _('at sunrise');
                    else if (val.offset<0)
                        sText = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                    else
                        sText = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                break;
                case 'dawn':
                    if (val.offset==0)
                        sText = _('at dawn');
                    else if (val.offset<0)
                        sText = Ext.String.format2(_("{time} before dawn"),{time:sText});
                    else
                        sText = Ext.String.format2(_("{time} after dawn"),{time:sText});
                break;
                case 'dusk':
                    if (val.offset==0)
                        sText = _('at dusk');
                    else if (val.offset<0)
                        sText = Ext.String.format2(_("{time} before dusk"),{time:sText});
                    else
                        sText = Ext.String.format2(_("{time} after dusk"),{time:sText});
                 break;
            }
            if (val.limitBefore!=null)  {
                sText+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(val.limitBefore/3600))),minute:pad(Math.floor(Math.abs(val.limitBefore/60)%60))});
            }
            if (val.limitAfter!=null)  {
                sText+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(val.limitAfter/3600))),minute:pad(Math.floor(Math.abs(val.limitAfter/60)%60))});
            }
            if (val.random!=null) {
                sText="&plusmn;" + sText;
            } 
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+sText+'</span>';
            else
            	return sText;        	
        }
    }
});

Ext.define('DSS.component.recurrenceColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.recurrencecolumn',
    renderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        if (val.recurrenceBase=="weekly") {
            var sString = "<span>";
            
            var fMo = false;
            var fDi = false;
            var fMi = false;
            var fDo = false;
            var fFr = false;
            var fSa = false;
            var fSo = false;
            if (val.timeArray!=null) {
                var recObject = val.timeArray;
                if (recObject.length == 7) {
                    var fActive=view.up().isFieldActive(record);
                    if (!fActive)
                    	return '<span style="color:grey;">'+sString + _("daily") + "</span>"+'</span>';
                    else
                    	return sString + _("daily") + "</span>";  
                }

                for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                    if (recObject[iIndex] == 'MO')
                        fMo = true;
                    if (recObject[iIndex] == 'TU')
                        fDi = true;
                    if (recObject[iIndex] == 'WE')
                        fMi = true;
                    if (recObject[iIndex] == 'TH')
                        fDo = true;
                    if (recObject[iIndex] == 'FR')
                        fFr = true;
                    if (recObject[iIndex] == 'SA')
                        fSa = true;
                    if (recObject[iIndex] == 'SU')
                        fSo = true;
                }
                if (recObject.length == 2)
                    if (fSa)
                        if (fSo) {
                        	var fActive=view.up().isFieldActive(record);
                        	if (!fActive)
                        		return '<span style="color:grey;">'+sString + _('on weekends')+'</span>'+'</span>';
                        	else
                        		return sString + _('on weekends')+'</span>';  
                        }

                if (recObject.length == 5)
                    if (fMo)
                        if (fDi)
                            if (fMi)
                                if (fDo)
                                    if (fFr) {
                                        var fActive=view.up().isFieldActive(record);
	                                    if (!fActive)
	                                    	return '<span style="color:grey;">'+sString + _('MO-FR')+'</span>'+'</span>';
	                                    else
	                                        return sString + _('MO-FR')+'</span>';
                                    }
                if (recObject.length == 1) {
                    if (fMo)
                        sString += _("on monday")+"</span>";
                    if (fDi)
                        sString += _("on tuesday")+"</span>";
                    if (fMi)
                        sString += _("on wednesday")+"</span>";
                    if (fDo)
                        sString += _("on thursday")+"</span>";
                    if (fFr)
                        sString += _("on friday")+"</span>";
                    if (fSa)
                        sString += _("on saturday")+"</span>";
                    if (fSo)
                        sString += _("on sunday")+"</span>";
                    
                    var fActive=view.up().isFieldActive(record);
                    if (!fActive)
                    	return '<span style="color:grey;">'+sString+'</span>';
                    else
                    	return sString;  
                    
                }
                if (recObject.length == 0) {
             

                    var fActive=view.up().isFieldActive(record);
                    if (!fActive)
                    	return '<span style="color:grey;">'+sString + _("no time defined")+'</span></span>';
                    else
                    	return sString + _("no time defined")+"</span>";        	

                }
            } else {
                var fActive=view.up().isFieldActive(record);
                if (!fActive)
                	return '<span style="color:grey;">'+sString + _("no time defined")+'</span></span>';
                else
                	return sString + _("no time defined")+"</span>";  
            } 

            
            if (fMo)
                sString += '<b>'+_('MO')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('MO')+'</span> ,';
            if (fDi)
                sString += '<b>'+_('TU')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TU')+'</span> ,';
            if (fMi)
                sString += '<b>'+_('WE')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('WE')+'</span> ,';
            if (fDo)
                sString += '<b>'+_('TH')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TH')+'</span> ,';
            if (fFr)
                sString += '<b>'+_('FR')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('FR')+'</span> ,';
            if (fSa)
                sString += '<b>'+_('SA')+'</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SA')+'</span> ,';
            if (fSo)
                sString += '<b>'+_('SU')+'</b>';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SU')+'</span>';

            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+sString+'</span></span>';
            else
            	return sString+"</span>";        	

        } else {
            var sText="<table>";
            if (val.timeArray!=null) {
                for (var iIndex=0;iIndex<val.timeArray.length;iIndex++) {
                    var oDate=new Date(val.timeArray[iIndex]);
                    if (!isNaN(oDate.getTime()))
                    	sText+="<tr><td>" + Ext.Date.format(oDate, "l, d.m.Y") + "</td></tr>";
                }
            }
            
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+sText+'</table></span>';
            else
            	return sText+"</table>";        	
            
        }
    },
});

Ext.define('DSS.component.timeStampColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timestampcolumn',
    renderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        
        if (val == null) {
            return _('-');
        } else if (val == "") {
            return _('-');
        } else {
            var oRecord = val;
            var oDate = new Date();
            oDate.setTime(parseInt(oRecord,10));
            var sText=pad(oDate.getDate()) + "." + pad(oDate.getMonth() + 1) + "." + oDate.getFullYear() + " - " + pad(oDate.getHours())
                    + ":" + pad(oDate.getMinutes()) + ":" + pad(oDate.getSeconds());

            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+sText+'</span>';
            else
            	return sText;        	            
        }
    }
});

Ext.define('DSS.component.EmailColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.emailcolumn',
    renderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
        if (view.up().customColumnRenderer!=null)
            if (view.up().customColumnRenderer[colIdx]!=null) {
                var sReturn=view.up().customColumnRenderer[colIdx](val, metadata, record, rowIdx, colIdx, store, view);
                if (sReturn != null)
                    return sReturn;
            }
        var triggerObject = val;
        if (triggerObject.messageType == 'email') {
            var sSubject=unescape(triggerObject.subject);
            var sMessage=unescape(triggerObject.message);
            if (sSubject.length==0)
                sSubject="<i>"+_('no subject')+"</i>";
            if (sMessage.length==0)
                sMessage="<i>"+_('no body')+"</i>";
            var sText= '<table><tr><td rowspan="3"><image src="'+dss.staticDataModel.baseImagePath+'dss/email.png"></td>'
                    + '<td rowspan="3" style="width:5px;"><image src="'+dss.staticDataModel.baseImagePath+'t.gif"></td>' + '<td>'+_('Receiver')+':</td><td>'
                    + triggerObject.receiver + '</td></tr>' + '<tr><td>'+_('Subject')+':</td><td>' + sSubject + '</td></tr>'
                    + '<tr><td>'+_('Body')+':</td><td>' + sMessage + '</td></tr></table>';
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	'<span style="color:grey;">'+sText+'</span>';
            else
            	return sText;
        }
        else {
            var fActive=view.up().isFieldActive(record);
            if (!fActive)
            	return '<span style="color:grey;">'+_('a message')+'</span>';
            else
            	return _('a message');        	
        }
    }
});


Ext.apply(Ext.data.SortTypes, {
    asTimestamp: function(oValue) {
        if (oValue == null) {
            return 0;
        } else if (oValue == "") {
            return 0;
        } else {
            return parseInt(oValue,10);
        }        
    },
    asTimespan: function(oValue) {
        return oValue;
    },
    asTrigger: function(oValue) {
        var pad10 = function(i) { 
            var sString=""+i
            while (sString.length<10)
                sString="0"+sString;
            return sString;
        };
        var sRetVal="";;
        var oAction = oValue[0];
        switch (oAction.type) {
            case 'zone-scene': { // scene,
                sRetVal="0";
                sRetVal += pad10(oAction.group);
                sRetVal += pad10(oAction.scene);
                sRetVal += pad10(oAction.zone);
                break;                
            }
            case 'device-scene': {
                sRetVal="1";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.scene);
                break;
            }
            case 'device-msg': {
                sRetVal="2";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.msg);
                break;
            }
            case 'custom-event': {
                sRetVal="3";
                sRetVal+=dss.staticDataModel.getHLENameFromId(oAction.event);
                break;
            }
            case 'device-sensor': {
                sRetVal="4";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.evt);
                break;
            }
        }
        return sRetVal;
    },
    asBoolean: function(oValue) {
        return (oValue==true)?1:0;
    }, 
    asEmail: function(oValue) {
        return oValue.receiver+'_' + oValue.subject;
    },
    asAction: function(oValue) {
        var pad10 = function(i) { 
            var sString=""+i
            while (sString.length<10)
                sString="0"+sString;
            return sString;
        };
        var oSelectValue=oValue[0];
        var sRet="";
        switch (oSelectValue.type){
            case 'zone-scene': {
                sRet="0";
                sRet += pad10(oSelectValue.group);
                sRet += pad10(oSelectValue.scene);
                sRet += pad10(oSelectValue.zone);
                break;
            }
            case 'zone-blink': {
                sRet="1";
                sRet += pad10(oSelectValue.group);
                sRet += pad10(oSelectValue.zone);
                break;
            }
            case 'device-scene': {
                sRet="2";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                sRet += pad10(oSelectValue.scene);
                break;
            }
            case 'device-blink': {
                sRet="3";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                break;
            }
            case 'device-value': {
                sRet="4";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                sRet += oSelectValue.value;
                break;
            }
            case 'custom-event': {
                sRet="5";
                sRet+=dss.staticDataModel.getHLENameFromId(oSelectValue.event);
                break;
            }
            case 'url': {
                sRet="6";          
                sRet+=oSelectValue.url;
                break;
            }
        }
        return sRet;
    },
    asCondition: function(oValue) {
        var pad10 = function(i) { 
            var sString=""+i
            while (sString.length<10)
                sString="0"+sString;
            return sString;
        };

        var sRet="";
        if (oValue.timeframe!=null)
        	return "0";
        if (oValue.weekdays!=null)
        	return "1";
        if (oValue.zoneState!=null)
        	return "2";
        if (oValue.systemState!=null) {
        	var oArray=[];
        	for (var iIndex=0;iIndex<oValue.systemState.length;iIndex++)
        		oArray.push(oValue.systemState[iIndex].name);
        	oArray=oArray.sort();
        	return "3" + oArray[0];
        }
        	
        
        return sRet;
    },    
    asTime: function(oValue){
        var retValue=0;
        switch (oValue.timeBase)
        {
            case 'sunset':
                retValue=350000;
            break;
            case 'sunrise':
                retValue=250000;
            break;
            case 'dawn':
                retValue=150000;
            break;
                retValue=450000;
             break;
        }
        retValue+=oValue.offset;
        return retValue;
    },    
    asRecurrence: function(oValue){
        if (oValue.timeArray!=null) {
            var recObject = oValue.timeArray;
            var fMo = false;
            var fDi = false;
            var fMi = false;
            var fDo = false;
            var fFr = false;
            var fSa = false;
            var fSo = false;
            if (recObject.length == 7)
                return 0;
            for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                if (recObject[iIndex] == 'MO')
                    fMo = true;
                if (recObject[iIndex] == 'TU')
                    fDi = true;
                if (recObject[iIndex] == 'WE')
                    fMi = true;
                if (recObject[iIndex] == 'TH')
                    fDo = true;
                if (recObject[iIndex] == 'FR')
                    fFr = true;
                if (recObject[iIndex] == 'SA')
                    fSa = true;
                if (recObject[iIndex] == 'SU')
                    fSo = true;
            }
            if (fSa)
                if (fSo)
                    if (!fMo)
                        if (!fDi)
                            if (!fMi)
                                if (!fDo)
                                    if (!fFr)
                                        return 20;
            if (!fSa)
                if (!fSo)
                    if (fMo)
                        if (fDi)
                            if (fMi)
                                if (fDo)
                                    if (fFr)
                                        return 10;
            if (recObject.length!=1) {
                var iReturnValue=100;
                if (fMo)
                    iReturnValue+=1;
                if (fDi)
                    iReturnValue+=2;
                if (fMi)
                    iReturnValue+=4;
                if (fDo)
                    iReturnValue+=8;
                if (fFr)
                    iReturnValue+=16;
                if (fSa)
                    iReturnValue+=32;
                if (fSa)
                    iReturnValue+=64;
                return iReturnValue;
            } else {
                if (fMo)
                    return 201;
                if (fDi)
                    return 202;
                if (fMi)
                    return 203;
                if (fDo)
                    return 204;
                if (fFr)
                    return 205;
                if (fSa)
                    return 206;
                if (fSo)
                    return 207;
            }
        }
        return 1000;
    }
});


Ext.define('DSS.gridPanel' ,{
    extend: 'Ext.grid.Panel',
    config: {
        enableColumnHide: false,
        enableColumnMove: false,
        selType: 'rowmodel',
        viewConfig: { forceFit: true }
    },
    disabledProperty:null,
    store: null,
    editorWindow: null,
    curSelectedEvent: null,
    btnNew : null,
    btnEdit : null,
    btnDelete : null,
    btnDisable : null,
    btnEnable : null,
    btnTest : null,
    defaultSortCol : null,
    defaultSortDirection:'ASC',
    fMultiselect:false,
    /* Parameter:
     *   * editor config
     *   * button config
     *   * columns
     *   * defaultSortCol
     *   * disabledProperty
     * */
    
    customColumnRenderer:{},
    customRendererOptions:{},
    statusBar:null,
    statusText:null,
    statusTextRight:null,
    grouperFn:null,
    inactiveField:null,
    inactiveEnablerField:null,
    setStatus:function (text,textRight) {
    	this.statusText.setText(text);
    	if (textRight!=null)
    		this.statusTextRight.setText(textRight);
    },
    isFieldActive:function(record) {
    	if (this.inactiveField==null)
    		return true;
    	if (record.get(this.inactiveField)!=null)
        	if (record.get(this.inactiveField)==true)
        		return false;
    	return true;
    },
    isEnablerActive:function(record) {
    	if (this.inactiveEnablerField==null)
    		return true;
    	if (record.get(this.inactiveEnablerField)!=null)
        	if (record.get(this.inactiveEnablerField)==true)
        		return false;
    	return true;    	
    },
    constructor: function(config) {
        if (config.multiselect!=null)
        	this.fMultiselect=config.multiselect;
    	if (this.fMultiselect) {
    		if (config.selModel==null)
    			config.selModel={};
    		config.selModel.mode = 'MULTI';
    	}
    	if (config.grouperField!=null) {
    		this.grouperField=config.grouperField;
    	}
    	if (config.inactiveField!=null)
    		this.inactiveField=config.inactiveField;
    	if (config.inactiveDisabledProperty!=null)
    		this.inactiveEnablerField=config.inactiveDisabledProperty;
    	this.statusText=Ext.create('Ext.toolbar.TextItem',{});
    	this.statusTextRight=Ext.create('Ext.toolbar.TextItem',{});
        this.statusBar=Ext.create('Ext.toolbar.Toolbar', {
        	items:[this.statusText,
        	       '->',
        	       {
        				text:_('Refresh'),
        				handler: function(){dss.staticDataModel.refreshDataModel();},
        				icon: dss.staticDataModel.baseImagePath + 'buttonIcons/refresh.png'
        			},
        	       this.statusTextRight]
        });
        config.bbar=this.statusBar;
    	
    	this.initConfig(config);
        
        this.addEvents('loadDataStore');
        this.addEvents('saveEntry');
        this.addEvents('enableEntry');
        this.addEvents('disableEntry');
        this.addEvents('deleteEntry');
        this.addEvents('testEntry');
        
        if (config.disabledProperty!=null)
            this.disabledProperty=config.disabledProperty;        
        var me=this;
        if (config.columns!=null) {
            for (var iIndex=0;iIndex<config.columns.length;iIndex++) {
                if (config.columns[iIndex].xtype=='disabledcolumn') {
                    config.columns[iIndex].listeners = {
                        checkchange : function (column,oValue,dataIndex, checked) {
                            if (oValue.get('disabled')==false)
                            {
                                me.fireEvent('enableEntry',me,oValue);
                            } else {
                                me.fireEvent('disableEntry',me,oValue);
                            }
                        }
                    } 
                }
            }
        }

        
        
        var oStoreConfig={
                storeId : config.storeConfig.storeId,
                fields : config.storeConfig.fields,
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            };
        if (this.grouperField!=null) {
            oStoreConfig.groupField=this.grouperField;
            config.features=[{ftype:'grouping',groupHeaderTpl:"{name}"}];
        }        
        
        me.store = Ext.create('Ext.data.Store', oStoreConfig);
        
        if (config.scope!=null) {
        	me.store.filter([
                 {filterFn: function(item) { 
                	 if (config.scope.fieldID!=null)
                		 if (config.scope.value!=null) {
                			 if (item.get(config.scope.fieldID)==null)
                				 return true;
                			 if (item.get(config.scope.fieldID)=="")
                				 return true;
                			 if (item.get(config.scope.fieldID)==config.scope.value)
                				 return true;
                			 return false;
                		 }
                	 return true;
                 }}
            ]);
        }
        
        if (config.buttonText.newButton!=null) {
            this.btnNew = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.newButton),
                iconCls : 'icon-add-action',
                handler : function() {
                    me.getSelectionModel().deselectAll();
                    me.editorWindow.show();
                    if (config.defaultNewEntryValues!=null) {
                    	
                    	me.editorWindow.setValues(Ext.JSON.decode(Ext.JSON.encode(config.defaultNewEntryValues)));
                    }
                    else
                    	me.editorWindow.setValues(null);
                }
            });
        }
        
        if (config.buttonText.editButton!=null) {
            this.btnEdit = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.editButton),
                iconCls : 'icon-edit-action',
                disabled : true,
                handler : function() {
                    me.editSelectedRecord();
                }
            });
        }
        
        if (config.buttonText.deleteButton!=null) {
            this.btnDelete = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.deleteButton),
                iconCls : 'icon-delete-action',
                disabled : true,
                handler : function() {
                    me.fireEvent('deleteEntry',me,me.curSelectedEvent);
                }
            });
        }
        
        if (this.disabledProperty!=null) {
            this.btnDisable = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.disableButton),
                iconCls : 'icon-disable-action',
                disabled : true,
                handler : function() {
                    me.fireEvent('disableEntry',me,me.curSelectedEvent);
                }
            });
            this.btnEnable = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.enableButton),
                iconCls : 'icon-enable-action',
                hidden : true,
                disabled : true,
                handler : function() {
                    me.fireEvent('enableEntry',me,me.curSelectedEvent);
                }
            });
        }
        if (config.buttonText.testButton!=null) {
            this.btnTest = new Ext.create('Ext.button.Button', {
                text : _(config.buttonText.testButton),
                iconCls : 'icon-test-action',
                disabled : true,
                handler : function() {              
                    me.fireEvent('testEntry',me,me.curSelectedEvent);
                }
            });
        }
        this.btnCustom=[];
        if (config.customButtons!=null) {            
            for (var iIndex=0;iIndex<config.customButtons.length;iIndex++) {
                this.btnCustom.push( new Ext.create('Ext.button.Button', {
                    text : _(config.customButtons[iIndex].text),
                    iconCls : config.customButtons[iIndex].iconCls,
                    disabled : false,
                    handler : function() {
                        this.thisFunction(me,me.curSelectedEvent);
                    }
                }));
                this.btnCustom[iIndex].thisFunction=config.customButtons[iIndex].handler;
            }
        }
        this.btnCustomRAlign=[];
        if (config.customButtonsRAlign!=null) {            
            for (var iIndex=0;iIndex<config.customButtonsRAlign.length;iIndex++) {
                this.btnCustomRAlign.push( new Ext.create('Ext.button.Button', {
                    text : _(config.customButtonsRAlign[iIndex].text),
                    iconCls : config.customButtonsRAlign[iIndex].iconCls,
                    disabled : false,
                    handler : function() {
                        this.thisFunction(me,me.curSelectedEvent);
                    }
                }));
                this.btnCustomRAlign[iIndex].thisFunction=config.customButtonsRAlign[iIndex].handler;
            }
        }
        this.editorWindow = Ext.create('DSS.component.Editor', config.editorConfig);
        this.editorWindow.on({
            'save' : function(oValue) {
                me.fireEvent('saveEntry',me,oValue);
            }
        });
        
        var oPropertyArray=[];
        if (this.btnNew!=null) {
            oPropertyArray.push(this.btnNew);
        }
        if (this.btnEdit!=null) {
            oPropertyArray.push(this.btnEdit);
        }
        if (this.btnDisable!=null) {
            oPropertyArray.push(this.btnDisable);
        }
        if (this.btnEnable!=null) {
            oPropertyArray.push(this.btnEnable);
        }
        if (this.btnTest!=null) {
            oPropertyArray.push(this.btnTest);
        }
        for (var iIndex=0;iIndex<this.btnCustom.length;iIndex++)
            oPropertyArray.push(this.btnCustom[iIndex]);
        oPropertyArray.push('->');
        for (iIndex = 0; iIndex<this.btnCustomRAlign.length;iIndex++){
        	oPropertyArray.push(this.btnCustomRAlign[iIndex]);
        }
        if (this.btnDelete!=null) {
            oPropertyArray.push(this.btnDelete);
        }

        config.tbar = {
            items : oPropertyArray
            };

        this.callParent(arguments);
        
        
        this.customColumnRenderer={};
        this.customRendererOptions={};
        if (config.columns!=null) {
            for (var iIndex=0;iIndex<config.columns.length;iIndex++) {
                if (config.columns[iIndex].customColumnRenderer) {
                    this.customColumnRenderer[iIndex]=config.columns[iIndex].customColumnRenderer;
                }
                if (config.columns[iIndex].customRendererOptions) {
                    this.customRendererOptions[iIndex]=config.columns[iIndex].customRendererOptions;
                }
            }
        }

        this.on({
            selectionchange: function(view, selections, options) {
            	if (me.inactiveField!=null) {
            		if (selections.length > 0) {
            			for (var iIndex=0;iIndex<selections.length;iIndex++) {
            				if (selections[iIndex].get(me.inactiveField)==true) {
            					view.deselect(selections[iIndex]);
            					return;
            				}
            			}
            		}
            	}
                if (selections.length > 0) {
                	if (selections.length==1)
                		me.curSelectedEvent = selections[0];
                	else
                		me.curSelectedEvent = selections;
                	
                    if (me.btnEdit!=null) {
                    	if (selections.length==1)
                    		me.btnEdit.setDisabled(false);
                    	else
                    		me.btnEdit.setDisabled(true);
                    }
                    if (me.btnDelete!=null) {
                        me.btnDelete.setDisabled(false);
                    }
                    
                    if (selections.length==1) {
                    	if (me.disabledProperty!=null) {
                    		var fOverride=false
                    		if (me.inactiveEnablerField!=null) {
                    			fOverride=me.curSelectedEvent.get(me.inactiveEnablerField);
                    		}
                    		
                    		if (!fOverride) {
		                        if (me.btnDisable!=null) {
		                            me.btnDisable.setDisabled(me.curSelectedEvent.get('disabled'));
		                            me.btnDisable.setVisible(!me.curSelectedEvent.get('disabled'));
		                        }
		                        if (me.btnEnable!=null) {
		                            me.btnEnable.setDisabled(!me.curSelectedEvent.get('disabled'));
		                            me.btnEnable.setVisible(me.curSelectedEvent.get('disabled'));
		                        }
                    		} else {
	                            me.btnDisable.setDisabled(true);
	                            me.btnDisable.setVisible(false);
	                            me.btnEnable.setDisabled(true);
	                            me.btnEnable.setVisible(false);
                    		}
	                        if (me.btnTest!=null) {
                        		me.btnTest.setDisabled(me.curSelectedEvent.get('disabled'));
	                        }
                    	}
                    } else {
                    	if (me.btnTest!=null)
                    		me.btnTest.setDisabled(true);
                    }
                    if (selections.length>1) {
	                    if (me.btnEnable!=null) {
	                    	me.btnEnable.setDisabled(false);
	                    	me.btnEnable.setVisible(true);
	                    }
	                    if (me.setDisabled!=null) {
	                    	me.btnDisable.setDisabled(false);
	                    	me.btnDisable.setVisible(true);
	                    }
                    }
                } else {
                    me.curSelectedEvent = null;
                    if (me.btnEdit!=null) {
                        me.btnEdit.setDisabled(true);
                    }
                    if (me.btnDelete!=null) {
                        me.btnDelete.setDisabled(true);
                    }
                    if (me.disabledProperty!=null) {
                        if (me.btnDisable!=null) {
                            me.btnDisable.setDisabled(true);
                        }
                        if (me.btnEnable!=null) {
                            me.btnEnable.setDisabled(true);
                            me.btnEnable.setVisible(false);
                        }
                        if (me.btnTest!=null) {
                            me.btnTest.setDisabled(true);
                        }
                    }
                }
            },          
            itemdblclick: function() {
                if (me.curSelectedEvent != null) {
                    me.editSelectedRecord();
                };
            },
            sortchange: function (header,col,direction)
            {
                me.defaultSortCol=col.dataIndex;
                me.defaultSortDirection=direction;
            }
        });
        var mThis=this;
        Ext.data.StoreManager.on('clear',function () {mThis.fireEvent('loadDataStore',mThis);});
        this.fireEvent('loadDataStore',this);
    },
    editSelectedRecord: function ()  {
        var oParams = {};
        for (var iIndex=0;iIndex<this.curSelectedEvent.fields.items.length;iIndex++) {
            var sKey=this.curSelectedEvent.fields.items[iIndex].name
            oParams[sKey] = this.curSelectedEvent.get(sKey);
        }
        this.editorWindow.show();
        this.editorWindow.setValues(oParams);
    },
    loadParameter: function (values) {
        this.store.removeAll();
        this.store.add(values);
        this.store.sort(this.defaultSortCol,this.defaultSortDirection);
        if (this.curSelectedEvent != null) {
            this.getSelectionModel().select(this.curSelectedEvent );
        }
        this.store.filter();
        this.doLayout();
    }
});